#include "lisp.h"
#include <setjmp.h>
#include <signal.h>
#include <stdio.h>

/*** #define calljmp()   setjmp(user_env[jmp_level++])   in lisp.h ***/
extern void timer_handler();
extern int ctrlcexit;

jmp_buf user_env[10];  /****  0 is used for top-level always ***/
/*** jmp_buf mc_jmpbuf[500];  **  0 is used for top-level always ***/

int debug_level=0;
extern int verbose_mode;
extern void timer_init(void);

void sigcheck();
void init_sig();

void long_jmp(int x,int val){
 longjmp(user_env[x],val);
}

/***  signal handler ***/
void sig_int(int sig){
 sprintf(iobuff,"signal %d received!\n",sig);
 lwritestr(STDERR,iobuff);
/*** for debug ***/
/*** init_sig();  ***/
/** signal(SIGINT,sig_int); **/
/*** long_jmp(0,sig);  ***/
 sigcode=sig;
  if(sig==SIGSEGV){ /*** segmentation violation ***/
     lwritestr(STDERR,"*** segmentation violation ***\n");
     lwritestr(STDERR,"*** jmp.c  ***\n");
    fprintf(stderr,"jmp_level=%d  goto error\n",jmp_level);
  if(ctrlcexit) s_bye(0,a_nil);
     error(E_segm,a_nil);
    /***  これは何故かうまくいく。  ***/
  }
  if(ctrlcexit&&(sig==SIGINT)) s_bye(0,a_nil);
  long_jmp(1,sig);  /*** V2.0 2010.6.8  **/
  /*** if(sig==SIGINT){ *** interrupt **
     sigcheck();
  }
  ***/
}

void init_sig(){
int n;
sigcode=0;
n=(long)signal(SIGSEGV,sig_int);
if(n==(long)SIG_ERR)  goto err;
n=(long)signal(SIGTSTP,sig_int);
if(n==(long)SIG_ERR)  goto err;
n=(long)signal(SIGINT,sig_int);
if(n==(long)SIG_ERR)  goto err;
n=(long)signal(SIGPROF,timer_handler);
n=(long)signal(SIGALRM,timer_handler);   
   if(verbose_mode){
       sprintf(iobuff,"timer handler set %x\n",n);
       lwritestr(STDMSG,iobuff);
   }
if(n==(long)SIG_ERR)  goto err;
   if(verbose_mode)
       lwritestr(STDMSG,"signal handler set\n");
timer_init();
    return;
 err:
    lwritestr(STDMSG,"*** signal error **** \n");
    long_jmp(0,119);
}
/** n=signal(SIGALRM,sig_int); **/

void sigcheck(){
  if(sigcode){
     sigcode=0;
     error(E_intrupt,a_nil);
    }
}

ptr s_sigclear(int narg,ptr env){
     sigcode=0;
    return a_t;
}

ptr s_sigcheck(int narg,ptr env){
     return MAKESINT(sigcode);
}

