#|
   GUI sftp
   2005.3.17
   FIFO is bad....
   may be  sftp is special?  No,  BUFSIZE
  sftp give up to write over 4096 bytes!

   net-run version
|#

(in-package "get-file")

(define *echo* #f)  ;;;;  #t for display sftp sesssion

(define *pid* 0)
(define *in-f*   0 )
(define *out*   0 )

(define *read-exit* #f)
(define *read-busy* #f)

;;;(define pid (net-run  "sftp" "sato@random") )
(define (run-sftp)
  (let* ((pid (net-run  "sftp" *access*) ))
   (set! *in-f* (cdr pid))
   (set!  *out* (cdr pid))
   (set! *pid* (car pid))
))

(define *buff* ())  ;;; for debug
(define *res* ())  ;;; for debug

;;;***  prompt cause hang up for read-line
(define *sftp-prompt* (reverse (string->list "sftp> ")))

(define (write-status x . color)
   (if (pair? color)
      (funcall *status* 'configure :text x :background (car color))
      (funcall *status* 'configure :text x)
  )
)

(define (reset-sftp local remote)
       (set! *read-exit* (lambda()  (dir-reset local)(dir-reset remote)))
        (if *echo*  (format #t "reset busy ~a ~a~%" *read-busy* *read-exit* ))
   (if (not *read-busy* ) 
       (funcall  *read-exit*)
   )
)

(define (read-p)
  (let* ((quit #f)(x 0)(res ()) (buf ()) (byte 0))
    (write-status "Working..." 'blue)
    (set!  *read-busy* #t)
    (set! *read-exit* #f)
    (while (not quit)
       (update)
       (set!  quit *read-exit*)
       (set! *buff* buf)
       (set! *res* res)
       (set! byte (char-ready? *in-f*))
       (if (not byte) (set! byte -1))
       (if (closed-port? *in-f*) (bye))
       (while (> byte 0)
        (set! x (read-char *in-f*))
        (if (eof-object? x) (bye))
           (if (or (eq? x #\return) (eq? x #\newline))
              (when (pair? buf)
                (set! x (list->string (reverse buf)))
                (push x res)
                (if *echo*  (format #t "~a~%" x ))
                (set! buf ())
              )
             (push x buf)
           ) 
         ;;; if (equal? x "sftp> ")
           (when (equal? buf *sftp-prompt*)
                 (set! quit 'res)
                (set! buf ())
          )
        (dec byte)
      )
      (and (not quit) 
            (process-exited? *pid*) (bye))
    )
    (write-status "OK" 'green)
    (when *read-exit*
       (funcall *read-exit*)
    )  
   (update)
    (set!  *read-busy* #f)
    (if (eq? quit 'res)
          res
          quit
    )
 )
)

(define (send-msg str)
  (format *out*  "~a~%" str)
  (flush *out*)
  (if *echo* (format #t  "<send> ~a~%" str))
)

(define (remote-glob . ext)
   (send-msg "ls")
   (read-p)
)

(define (remote-pwd)
  (let* ((s 0)(n 0))
   (send-msg "pwd")
   (set! s (read-p))
   (set! s (car s))
   (set! n (string-index ":" s))
   (substring s (+ n 2) :end)
))

(define (remote-chd dir)
  (let* ((s 0)(n 0))
   (send-msg (tk-string "cd " dir))
   (read-p)
   dir
))
