;;;; compile-file given *argv*
;;;;

(require "compiler")

(if (pair? *argv*)
  (while (pair? *argv*)
     (compile-file (car *argv*))
     (set! *argv* (cdr *argv*))
  )
  (let* ((s (glob-file "*.ss")) (f 0)(fr 0))
    (while (pair? s)
       (set! f (pop s))
       (set! fr (string-append (substring f 0 :end -2) "sr"))
       (if (file-exists? fr)
           (if (> (file-time fr)(file-time f)) (set! f #f))
       )
       (if f  (compile-file f))
    )
   )
)
   
(bye)

