;;    text widget
;;;   2002  sed.scm
;;;    higher verion of text-new.scm
;;;   2002.8.20  chdir enable
;;;   Backup file  is automatically create
;;;  2003.11.4   ss version
;;;
;;;(load "get-file")
(require "dialog")
(load "get-lineno")
(load "replace-dialog")
(load "open-text-dialog")
;;;(load "mesg")
(load "save-dialog")
(load "ssed-help")
 ;;(define *wdir* (getcwd))    mazui for multi editor
(define *sed-win* ())
(define *sed-win-first* ())
;;;(define-macro (call-tk win . args)
;;;  `(apply (eval ,win ()) ,@args ())   ;;; needs () for ss
;;;)
;;;   wdir control --for multi editor
(define (wdir-ctrl wdir-win)
  (let ((s (getcwd))(home 0))
     (set! home s)
    (lambda (cmd)
      (cond ((eq? cmd #t)
               s)
            ((eq? cmd #f)
               home)
            (#t
               (chdir cmd)
               (set! s (getcwd))
               (eval `(,wdir-win 'configure :text ,s) ()) ;;; needs () for ss
               s
             )
       )
     )
))

(define (gen-ssed name)
  (set! name (gen-toplevel name))
    (if (null? *sed-win*) (set! *sed-win-first* name)) 
     (push name *sed-win*)
   name
)

(define (only-space s)
   (let ((lis (string->list s)))
     (do ((c 0)(ans #t))
         ((null? lis) ans)
         (if (eq? (pop lis) #\space) () (set! ans #f))
     )
))

(define (ssed . files) 
   (let* ((ent-f 0)(ent-r 0)(ent 0)(txt 0)(fname 0)(radio-sel 0)(line-number 0)(line-setf 0)
     (ent-j 0)     (menubar 0)(menu-file 0)(menu-edit 0)(menu-tool 0)
      ( topw (gen-ssed  '.text))
      ( wdir (wdir-ctrl (tk-name topw '.wdir))))
      ;;; don't use define ,  define 'sentences are converted  letrec! not let* 
    ;;;  wdir control function
    (set! txt (tk-name topw ".tx"))
    (set! line-number (tk-name topw '.linenumber) )
    (label line-number :text "Line No" :bg 'snow)
    (set! line-setf (lambda()(line-check txt line-number)))

     (set! menubar (tk-name topw '.menubar))
    ((function topw)  'configure :menu menubar)
    (menu menubar)
     (set! menu-file (tk-name menubar '.file))
     (set! menu-edit (tk-name menubar '.edit))
     (set! menu-tool (tk-name menubar '.tool))

    ((function menubar)'add 'cascade :label "ファイル(F)" :underline 5 :menu menu-file) 
    ((function menubar)'add 'cascade :label "編集(E)" :underline 3 :menu menu-edit) 
    ((function menubar)'add 'cascade :label "Tool(T)" :underline 5 :menu menu-tool) 
    (menu menu-file :tearoff 'no)
    ((function menu-file) 'add 'command :label "Open(O)" :underline 5 
                :command `(my-open ',topw ,wdir))
    ((function menu-file) 'add 'command :label "Save(S)" :underline 5 
            :command `(my-save ',topw ,wdir))
     ((function menu-file) 'add 'separator)
    ((function menu-file) 'add 'command :label "New (N)" :underline 5 
             :command '(ssed))
    ((function menu-file) 'add 'command :label "Home(H)" :underline 5 
               :command `(my-home ',topw  ,wdir))
     ((function menu-file) 'add 'separator)
    ((function menu-file) 'add 'command :label "Exit(X)" :underline 5 
             :command `(my-exit ',topw  ,wdir))

    (menu menu-edit  :tearoff 'no)
    ((function menu-edit) 'add 'command :label "Copy(C)" :underline 5 
             :command  `(tk_textCopy  ',txt))
    ((function menu-edit) 'add 'command :label "Cut (W)" :underline 5 
             :command  `(tk_textCut   ',txt))
    ((function menu-edit) 'add 'command :label "Paste(Y)" :underline 6 
             :command  `(tk_textPaste  ',txt))
    
     (menu menu-tool  :tearoff 'no)
    ((function menu-tool) 'add 'command :label "SSload" ;;:underline 7 
            :command `(my-load ',topw ))
    ((function menu-tool) 'add 'command :label "Check " ;;:underline 7 
            :command `(my-check ',txt))
    ((function menu-tool) 'add 'command :label "Tag Clear" ;;:underline 10 
            :command `(tag-clear ,txt))
    ((function menu-tool) 'add 'command :label "Tag Jump (J)" :underline 10 
            :command `(tag-jump ,txt))
    ((function menu-tool) 'add 'command :label "Jump Line(L)" :underline 10 
           :command 
           `(let ((n (get-lineno-dialog (winfo 'x ,txt)(winfo 'y ,txt))))
             (when n (jump-line-no ,txt n)(,line-setf))) )
    ((function menu-tool) 'add 'command :label "Help"  ;;;:underline 10 
            :command '(ssed-help))

    ;(wm 'geometry topw "900x750+100+100")
    (wm 'title topw (tk-string "SS editor" topw))
    (label (tk-name topw '.wdir) :text (wdir #t) :fg 'blue)
    (frame (tk-name topw '.f))
    (label (tk-name topw '.f.lb) :text "File Name" :bg 'snow)
    
    (entry (tk-name topw '.f.file)  :bg 'snow :width 20 :font '(courier 12))
     (grid (tk-name topw '.f.lb)(tk-name topw '.f.file))
     (frame (tk-name topw '.fr))
    (grid  (tk-name topw '.wdir) (tk-name topw '.f)
       line-number  
          )
     (frame (tk-name topw '.fr2))
      (set! ent-f (tk-name topw '.fr2.word))
     (button (tk-name topw '.fr2.find) :text "Find" 
            :command `(begin (my-find ',txt ',ent-f) (,line-setf)) :borderwidth 5)
     (entry ent-f :bg 'snow :width 20 :font '(courier 12))
       (set! ent-r (tk-name topw '.fr2.reword))
      (button (tk-name topw '.fr2.replace) :text "Replace" 
          :command `(my-replace ',txt ',ent-r  ,ent-f):borderwidth 5)
     (entry ent-r :bg 'snow :width 20 :font '(courier 12))
     (grid  (tk-name topw  '.fr2.find)(tk-name topw '.fr2.word)
           (tk-name topw '.fr2.replace)(tk-name topw '.fr2.reword)
            ;fname
           :padx 6 :pady 6)
     (grid (tk-name topw '.fr2) :columnspan 4)
     ;(label (tk-name topw '.jmp) :text "jump line")
     ;(entry (tk-name topw '.jmpent)  :bg 'snow :width 20 :font '(courier 12))
     ;(grid   (tk-name topw '.jmp)(tk-name topw '.jmpent))
     (text txt :relief 'solid 
           :font '(courier 12):padx 10 :pady 20
           :yscrollcommand (lambda l (apply (eval (tk-name topw '.yscroll)() ) 'set l)) )
    (scrollbar (tk-name topw '.yscroll) :orient 'vertical 
          :command (lambda l (apply (eval txt () ) 'yview l))  )
    (grid  txt :sticky 'news :columnspan 10 )
     ;;;; 04.5.6   text enable expand
     (grid 'rowconfigure topw 2 :weight 1)
      (grid 'columnconfigure topw 8 :weight 1)
     ;;;
    (grid (tk-name topw '.yscroll) :sticky 'ns 
          :column 10 :row (list-ref (grid 'info txt ) 5))
    
   
    (funcall txt 'tag 'configure 'error :foreground 'red)
    (funcall txt 'tag 'configure 'list :foreground 'brown)
    (funcall txt 'tag 'configure 'string :foreground 'darkgreen)
    (funcall txt 'tag 'configure 'comment :foreground 'violet)
    (funcall txt 'tag 'configure 'replace :foreground 'orange)
    (funcall txt 'tag 'configure 'select :underline 'true)
     (funcall txt 'tag 'configure 'findall :foreground 'blue)
     (funcall txt 'tag 'configure 'jump :background 'grey)

    (bind txt "<parenright>" (lambda ()(my-check txt)))
     (bind txt "<quotedbl>" (lambda ()(my-check txt)))
     (bind txt "<Key>" + line-setf)
     (bind txt "<Button>" + line-setf)
     (bindtags txt (list "Text" txt topw "all")) ;;; Text yuusen
     (bindtags ent-f (list "Entry" ent-f topw "all")) ;;; Entry yuusen
      (bind txt "<F3>" (lambda ()(my-f3 txt ent-f)(line-setf) ))
       (bind txt "<F5>" (lambda ()(my-f5 txt ent-r)(line-setf)) )
       (bind txt "<F7>" 
             (lambda ()(tag-jump txt)(line-setf)) )
      (bind txt "<Control-j>" 
             (lambda ()(tag-jump txt)(line-setf)) )

      (bind ent-f "<KeyPress>"
         (lambda(|K| |A|) 
              ;(format #t"input ~s~%" |K|)
              (cond ((equal? |K| "BackSpace"))
                    ((equal?  |K| "Return")(focus txt)(line-setf))
                    ((equal? |K| "space")
                       (if (only-space (funcall ent-f 'get))
                            ();do noting
                          (begin (my-find txt ent-f)(focus ent-f))
                       )
                    )
                    (#t 
                       (if (equal? |A| "")
                            () ; do nothing
                          (begin  (my-find txt ent-f)(focus ent-f))
                        )
                    )
              )
            ))
     (bind ent-r "<Return>" 
           (eval `(lambda ()(my-replace ,txt ,ent-r ,ent-f)) () )) ;;;needs ()
      (bind txt "<ButtonPress-3>" (lambda(X Y) (tk_popup menu-edit  X Y )))
      (bind txt "<Control-q>" 
             (lambda() (getline-no txt)))
       
    (if (pair? files)
       (let ((file 0))
           (set! file (pop files))
           (insert-file file txt 'end)
           (funcall (tk-name topw '.f.file) 'insert 'end file  )
       )
     )          
     (do ((file 0))
         ((null? files))
         (set! file (pop files))
         (ssed  file)
     )
    (jump-line-no txt 0 )
   txt
))

(define (line-check txt line)
  (funcall  line 'configure :text (funcall txt 'index 'insert))
)

(define (my-exit top wdir)
  (let ((s 0) (fname 0)(ans #\s))
      (set! s (funcall (tk-name top '.f.file) 'get ))
      (chdir (wdir #t))
      (if (compare-file-text s top)
          (sed-fin top)
        (begin
           (set! ans  (save-dialog))
           (cond ((eq? ans #t)
                     (my-save top wdir)(sed-fin top))
                 ((eq? ans #\c)  )
                 ( #t (sed-fin top))
           )
        )        
      )
))
(define (sed-fin top)
  (set! *sed-win* (remove top *sed-win*))
   (destroy top)
)
(define (my-home top wdir)
  (let ((h (wdir #f)))
    (wdir h)
))

(define (sed-error msg)
   (format #t "****  sed error  ~s ~%"  msg)
   (mesg-dialog msg)
)

(define (my-open top wdir)
  (let ((s 0) (fname 0)(mode #\s)(txt (tk-name top '.tx)) )
     (chdir (wdir #t))
    (set! s (get-file-name "*"))
     ;;;(wdir (getcwd))
    (if (or (equal? s "") (eq? s #f))
         (if (eq? s #f)(set! mode #f))
      (begin
         (set! fname (funcall (tk-name top '.f.file) 'get ))
         (if (equal? fname "")
               (funcall (tk-name top '.f.file) 'insert 'end s  )
             
               (set! mode (open-text-dialog))
                
         )
          ; (.text.file 'configure :text s)
        (cond ((or (eq? mode #\a) (eq? mode #\s))
                   (insert-file s txt 'end))
              ((eq? mode #\i)
                   (insert-file s txt 'insert))
              ((eq? mode #\n)
                   (ssed s) )    
        )
      )
    )
   (when (eq? mode #\s)
       (jump-line-no txt 0)
        (wdir (getcwd))) ;;; New file edit
 ))
(define (insert-file file txt pos)
  (let ((s 0))
     (set! s (open-input-file file))
         (do ((x (read-line s)(read-line s)))
           ((eof-object? x)(close-input-port  s))
           (funcall  txt 'insert pos x )
           (funcall  txt 'insert pos #\newline )
         )
))
(define (compare-file-text file top)
  (let ((s 0)(text "")(tx 0)(pos 1)(ind1 0)(ind2 0)(flag #f))
     ;; text (funcall (tk-name top '.tx) 'get "1.0" 'end))
      (set! tx (tk-name top '.tx))
     (if(file-exists? file)
       (begin
         (set! flag #t)
        (set! s (open-input-file file))
         (do ((x (read-line s)(read-line s))(bun 0))
           ((or (eof-object? x) (not flag)) (close-input-port  s))
           (set! ind1 (tk-string pos "." 0))
            (set! ind2 (tk-string pos "." 'end)) 
            (set! bun(funcall  tx 'get ind1 ind2 ) )
           (set! flag (equal? bun x))
           (set! pos (+ pos 1))
         )
        )
       (begin
          (set! s(funcall  tx 'get "1.0" 'end ) )
           (if (< (string-length s) 2) (set! flag #t))
              ;;;(format #t "~s ~%" s))   null-text include only \n !!!
        )
     )
  flag
))
(define (my-save top wdir)
  (let ((s 0) (text ""))
     (set! s (funcall (tk-name top '.f.file) 'get ))
     (chdir (wdir #t))
     (if (equal? s "")
        (sed-error "file name?")
        (begin
            (set! s (open-output-file s))
            (set! text (funcall (tk-name top '.tx) 'get "1.0" 'end))
            (display text s)
            (close-output-port  s)
            (funcall (tk-name top '.f.lb) 'configure :text "Saved!" :bg 'red)
            (after 3000 
               `(and (winfo 'exists (tk-name ',top '.f.lb))
                    (funcall (tk-name ',top '.f.lb)
                           'configure :text "File Name" :bg 'snow))
            )
        )
     )
    
 ))
(define (my-load top)
  (let ((s 0) (text "") (port 0))
            (set! text (funcall (tk-name top '.tx) 'get "1.0" 'end))
            (set! port (open-input-string  text ))
            (set! s(catch  (load port)))
            (if s (format #t "**** error  loading ~s~%" text))
            ; (do ((x (read port)(read port)))
            ;      ((eof-object? x)(close-input-port  port))
            ;      (write (eval x ()))   ;;; needs () for ss
            ;      (newline)
            ;  )
            (close-port  port)
      
 ))
(define (my-clear top wdir)
   (let ((s 0) (ans #\s))
      (set! s (funcall (tk-name top '.f.file) 'get ))
      (chdir (wdir #t))
      (if (compare-file-text s top)
          (text-clear top)
        (begin
           (set! ans  (save-dialog))
           (cond ((eq? ans #t)
                     (my-save top wdir)(text-clear top))
                 ((eq? ans #\c)  )
                 ( #t (text-clear top))
           )
        )        
      )
))
(define (text-clear top)
   (funcall (tk-name top '.tx) 'delete "1.0" 'end) 
     ;;; 1.0 means  line1, column 0
   (funcall (tk-name top '.f.file) 'delete 0 'end) 
)
(define (my-find txt ent)
   (let (( s (funcall ent 'get)))
     (if (equal? s "") ()  ;do nothing (sed-error "string empty")
       (begin
             (funcall txt 'tag 'remove 'findall "1.0" 'end)
           (set! s(all-find-txt txt s))
           (if (null? s)
                  (mesg-dialog "Not find" 500) 
                (begin
                 (funcall txt 'see (car s))
                 (funcall txt 'mark 'set 'insert (car s))
                  (focus txt)
                )  
           )
        )
      )
))

(define (my-replace txt ent  ent-f)
   (let (( s (funcall ent 'get))
          (ask 1)   ;;;(sel #t))
          (find (funcall txt 'tag 'nextrange 'findall 'insert))  )
    ;(format #t "replace:~s" s)
     (if (null? find)
           (begin
              (my-find txt ent-f)
               (set! find (funcall txt 'tag 'nextrange 'findall "1.0")  )
               (if (null? find) (sed-error "find empty"))
            )
      )
      (funcall txt 'tag 'remove 'replace '(1 . 0) 'end)
       (do ((first 0)(end 0)(n 0)(ans #t)(can #f))
           ((or can (null? find))(focus txt))
             ;(format #t "find ~s" find)
           (set! first (pop find))
           (set! end (pop find))
            (if (equal? ask 1)
              (begin
                  (funcall txt 'tag 'add 'select first end)
                   (funcall txt 'see first)
                  (set! ans (replace-dialog))
                  (funcall txt 'tag 'remove 'select first end)
                  (cond ((eq? ans #\a) (set! ask 2))
                        ((eq? ans #\c) (set! ans #f)(set! can #t))  )                      
               )
            )
            (if ans
               (begin
                (  funcall txt 'delete first end)
                (funcall txt 'insert first s 
                   'replace)
                   ;;;'(replace))
                )
                ;(funcall txt 'tag 'remove (tk-name 'find n) first end)
            )
              (set! find (funcall txt 'tag 'nextrange 'findall end))
        )
      
))    

(define (my-f3 txt ent-f)
   (let (( s (funcall ent-f 'get))
          (find (funcall txt 'tag 'nextrange 'findall "insert + 1 chars"))
            (ind 0)  )
     (if(pair? find)
       (my-f3-sub txt find) 
       (begin   ;;; back to top
          (set! find  (funcall txt 'tag 'nextrange 'findall '(1 . 0)))
          (when (pair? find)(my-f3-sub txt find)(mesg-dialog "Return to Top" 500))
       )
     )
))   

(define (my-f3-sub txt find)
  (let ((ind (car find)))
        (funcall txt 'see ind)
        (funcall txt 'mark 'set 'insert ind)
))

(define (tag-jump txt)
      (let (( s 0)
          (find (funcall txt 'tag 'ranges 'jump)) (ind 0)  )
       
     (when  (not (null? find))
        
        (set! s (pop find))
         (pop find)
         (do ((ans #f)(x 0))
             ((or ans (null? find)) (if ans (set! s ans)))
              (set! x (pop find))
              (if (funcall txt 'compare x '> 'insert)
                  (set! ans x)
               )
              (pop find)
          ) 
       (funcall txt 'see s)
        (funcall txt 'mark 'set 'insert s)
     )    
))

(define (tag-clear txt)
  (funcall txt 'tag 'remove 'jump "1.0" 'end)
)

(define (my-f5 txt ent)
   (let (( s (funcall ent 'get))
          (find (funcall txt 'tag 'ranges 'replace)) (ind 0)  )
     (if (null? find)
        (sed-error "replaced empty")
      (begin     
        (set! ind (funcall txt 'search s  'insert ))
        (if (funcall txt 'compare ind '== 'insert)
              (set! ind (funcall txt 'search s  (next-pos ind 1) )))
         (funcall txt 'see ind)
         (funcall txt 'mark 'set 'insert ind) 
      )
    )    
))
    
(define (find-txt txt pat index last)
   ;;;-- indicates end of option 
   ;;;   it needs for pat is beginning from '-'  !
   (funcall txt 'search "--" pat index last)
) 

(define (jump-line txt ent)
  (let (( s (funcall ent 'get)))
    (jump-line-no txt (string->number s))   
)) 

(define (jump-line-no txt n)
     
   (funcall txt 'mark 'set 'insert (tk-string n ".0"))
   (funcall txt 'see (tk-string n ".0"))
   (focus txt)
) 
(define  (getline-no txt )
  (let ((ind 0))
     ;;;(set! ind (get-mark "current" txt "1.0"))
     (set! ind (get-mark "insert"  txt "1.0"))
     (funcall txt 'tag 'add 'jump ind)
))
(define (get-mark mark txt start)
  (let ((lis  (funcall txt 'dump :mark start 'end)))
    ;(format #t "lis ~s~%" lis)
    (do ((x 0)(ind #f))
        ((or ind (null? lis))ind)
                (set! x (pop lis))
        (if (equal? mark (cadr x)) (set! ind (caddr x)))
    )
))
(define (all-find-txt txt pat)
   (do ((res ()) (pos '(1 . 0))(n 0) (len (string-length pat) ))
       ((not pos) (reverse res))
       (set! pos (find-txt txt pat pos 'end))
        (if pos
           (begin
              (push pos res)
               ;(funcall txt 'tag 'add (tk-name 'find n) pos (next-pos pos len ))
                (funcall txt 'tag 'add 'findall pos (next-pos pos len ))
               (set! pos (next-pos pos len))
               ;(set! n (- 1 n))
            )
         )
    )
)
(define (next-pos pos n)
      (tk-string (car pos) #\. (cdr pos) " +" n " chars")
)
(define (text-index n)
   (string-append "1.0 +" (number->string n)" chars"))

(define (my-check txt)
  (let ((text "") (pos '(1 . 0))(len 0)(list-f #f)(list-e #f))
    (set! text (funcall txt 'get pos 'insert))
     (set! len (string-length text))
     (funcall txt 'tag 'remove 'list pos 'end)
       (funcall txt 'tag 'remove 'error pos 'end)
       (funcall txt 'tag 'remove 'string pos 'end)
  (do ((mode 0)(mode-stack '(top)) (stack ())
       (c 0)(n 0))
     
      ((= n len))      
      (set! c (string-ref text n))
      ;(display c)
        (set! mode (car mode-stack))
        
      (cond ((eq? mode 'yen) (pop mode-stack))
            ((eq? c #\\) (push 'yen mode-stack))
            ((eq? c #\")
               (if (eq? mode 'string)
                 (begin 
                   (pop mode-stack)
                   (funcall txt 'tag 'add 'string (pop stack)
                        (text-index (+ n 1)) ) 
                  )
                 (begin
                    (push 'string mode-stack)
                    (push (text-index n) stack)
                  )
                )
              )
             ((eq? mode 'string))
             ((eq? mode 'comment)
                 (if (eq? c #\newline )
                    (begin
                        (pop mode-stack)
                           
                        (funcall txt 'tag 'add 'comment (pop stack)
                        (text-index (+ n 1)) ) 
                     )
                 )
              ) 
             ((eq? c #\;)
                 (push 'comment mode-stack)
                  (push (text-index n) stack)
              )
             ((eq? c #\) )
                (if (eq? mode 'list)
                 (begin 
                   (pop mode-stack)
                   ;(funcall txt 'tag 'remove 'list pos 'insert)
                   ;(funcall txt 'tag 'add 'list (pop stack)
                   ;    (text-index (+ n 1)))
                   (set! list-f (pop stack))
                   (set! list-e (text-index (+ n 1))) 
                  )
                 (begin
                    (funcall txt 'tag 'add 'error (text-index n)
                          (text-index (+ n 1)))
                  )
                ) 
               )
             ((eq? c #\()            
                    (push 'list mode-stack)
                    (push (text-index n) stack)
                )   
             (#t )
        )         
                                              
      (set! n (+ n 1))
  )
   (funcall txt 'tag 'remove 'list pos 'insert)
   (if list-f (funcall txt 'tag 'add 'list  list-f list-e))
))



