;;;;  only for special form
;;;;
(in-package "ss")
#|  ---> macro.ss
(define-syntax special-syntax (syntax-rules 
        (syntax-rules *literal* *macro-key* macro:*macro-bind*)
  ((special-syntax key  (syntax-rules  lite
     (pat1 temp1) (pat2 temp2) ...) )
    ;;;;(let* ((alias (gensym)))
    (let* ((alias (special-alias 'key)))
       (remove-macro 'key)
       (set! *literal*  'lite)
       (set! *macro-key*  'key)  
       (set! macro:*macro-bind* (cons (list 'key alias 1 'lite
               (rule-trans '((pat1 temp1 )(pat2 temp2) ...) ())
               '((pat1 temp1 )(pat2 temp2) ...) ())
                macro:*macro-bind*) )
       (if (symbol-bind? 'key)
            (symbol-value-set  alias (symbol-value 'key))
       )
       (macro:macro-alias 'key) 
     )
  ) )
)
|#
#|
(special-syntax  define (syntax-rules ()
   ((define (f . x) b ...)
     (define f (lambda x b ...))  )
   )
)
|#

(special-syntax let* (syntax-rules (begin define )
  ((let* args (define x y) ... (begin a ...) b ...)
     (let* args (define x y ) ... a ... b ...))  
  ((let* args (define (f .  x) c ... ) (define a ...)...  b ...)
     (let* args (define a ...) ... 
              ("define-symbol"  f (lambda x c ...)) b ...))
  ((let* args (define f x) (define g y) ... b ...)
     (let* args (define g y)... ("define-symbol"  f x) b ...))
 ;;; ((let* args  (define (f . b ))))
  ((let* args ("define-symbol"  a b) ("define-symbol"  x init) ...  body ...)
    (let* args 
       (letrec ((a b) (x init) ...)
           body ...))   )
   )
)

(special-syntax letrec (syntax-rules (begin define )
  ((letrec args (define x y) ... (begin a ...) b ...)
     (letrec args (define x y ) ... a ... b ...))
  ((letrec args (define (f .  x) c ... ) (define a ...)...  b ...)
     (letrec args (define a ...) ...
              ("define-symbol"  f (lambda x c ...)) b ...))
  ((letrec args (define f x) (define g y) ... b ...)
     (letrec args (define g y)... ("define-symbol"  f x) b ...))
 ;;; ((let* args  (define (f . b ))))
  ((letrec args ("define-symbol"  a b) ("define-symbol"  x init) ...  body ...)
    (letrec args
       (letrec ((a b) (x init) ...)
           body ...))   )
   )
)

(special-syntax lambda (syntax-rules (begin define )
  ((lambda args (define x y) ... (begin a ...) b ...)
     (lambda args (define x y ) ... a ... b ...))
  ((lambda args (define (f .  x) c ... ) (define a ...)...  b ...)
     (lambda args (define a ...) ...
              ("define-symbol"  f (lambda x c ...)) b ...))
  ((lambda args (define f x) (define g y) ... b ...)
     (lambda args (define g y)... ("define-symbol"  f x) b ...))
 ;;; ((let* args  (define (f . b ))))
  ((lambda  args ("define-symbol"  a b) ("define-symbol"  x init) ...  body ...)
    (lambda args
       (letrec ((a b) (x init) ...)
           body ...))   )
   )
)

(special-syntax let-syntax (syntax-rules (begin define )
  ((let-syntax args (define x y) ... (begin a ...) b ...)
     (let-syntax args (define x y ) ... a ... b ...))
  ((let-syntax args (define (f .  x) c ... ) (define a ...)...  b ...)
     (let-syntax args (define a ...) ...
              ("define-symbol"  f (lambda x c ...)) b ...))
  ((let-syntax args (define f x) (define g y) ... b ...)
     (let-syntax args (define g y)... ("define-symbol"  f x) b ...))
 ;;; ((let* args  (define (f . b ))))
  ((let-syntax args ("define-symbol"  a b) ("define-symbol"  x init) ...  body ...)
    (let-syntax args
       (letrec ((a b) (x init) ...)
           body ...))   )
   )
)

(special-syntax letrec-syntax (syntax-rules (begin define )
  ((letrec-syntax args (define x y) ... (begin a ...) b ...)
     (letrec-syntax args (define x y ) ... a ... b ...))
  ((letrec-syntax args (define (f .  x) c ... ) (define a ...)...  b ...)
     (letrec-syntax args (define a ...) ...
              ("define-symbol"  f (lambda x c ...)) b ...))
  ((letrec-syntax args (define f x) (define g y) ... b ...)
     (letrec-syntax args (define g y)... ("define-symbol"  f x) b ...))
 ;;; ((let* args  (define (f . b ))))
  ((letrec-syntax args ("define-symbol"  a b) ("define-symbol"  x init) ...  body ...)
    (letrec-syntax args
       (letrec ((a b) (x init) ...)
           body ...))   )
   )
)


#|
 (s '(let* ((x 5))
         (define foo (lambda (y) (bar x y)))
         (define bar (lambda (a b) (+ (* a b) a)))
         (foo (+ x 3)) ))

 (s '(let* ((x 5))
         (define (foo y) (bar x y))
         (define (bar a b) (+ (* a b) a))
         (foo (+ x 3)) ))

(let* ((x 5))
         (define (foo y) (bar x y))
         (define (bar a b) (+ (* a b) a))
         (foo (+ x 3)) )
;;;; 45
|#

