;;; 2010.7.2  
;;;  match-data  ---> dot-env
;;;

(define *top-env* ())
(define *dot-env* ())

(define (dot-env)
  (let* ((data *match-data*) (s data) (res ())(level *max-level*))
    (set! s (dot-env-sepa data))
    (set! *top-env* (car s))
    (set! data (cdr s))
    (do ((i 1 (+ i 1)))
        ((> i *max-level*))
      (set! s (dot-env-level data i))
      (push s res)
    )
   (set! *dot-env* (reverse res))
)) 

(define (dot-env-sepa data)
 (let* ((x 0)(res0 ())(res1 ()))
      (while (pair? data)
         (set! x (pop data))
         (if (symbol? (car x))
                (push x res0)
                (push x res1)
         )
      )
  ;; (format #t "top: ~s ~% dot:~s~%" res0 res1)
   (cons res0 res1)
))
(define (dot-env-level data level)
 (let* ((x 0)(v 0)(res ()))
      (while (pair? data)
         (set! x (pop data))
         (if (= level 0)
                (if (and (pair? x)(symbol? (car x)))  ;;; 2010.8.12
                   (push x res)
                )
               (begin
                 (set! v (car x))
                 (set! x (cdr x))
                 (if (pair? x)    ;;;  maybe () if v ... matches 0 elements!
                     (if (not (symbol? (car x)))
                        (push  (dot-env-level   x (- level 1)) res)
                     )
                   ;;;;  empty dot-data for a place 
                   ;;; (if (and (pair? v)(eq? (car v) :var))
                   (if (and (pair? v)(eq? (car v) patvar))
                     (push (empty-data  (list (cadr v))  level  ) res)
                   )
                 )
               )
        )      
      )
   ;;(format #t "res ~s ~% level ~s~%" res level)
   (reverse res)
))
(define (empty-data x level)
   (if (= level 0)
            x
      (empty-data (list x) (- level 1))
   )
)

