;;;
;;;   see quadricdemo.ss
;;;   2002.11.8
;;;;  by S.Sato
;;;   2003.10.23  ss OK!

(define (tk_optionMenu path title . menus)
 (let*  ((m (tk-name path ".m"))(tag 0))
  (menubutton  path :text title :menu m )
  (menu m  :tearoff 'no)
  (foreach menu menus
      (funcall m 'add 'radiobutton :label menu :variable title  :value menu)
   )
  (set! tag (tk-string path))
  (bind tag "<Button-1>" 
     (lambda (x y) 
       (funcall m 'post (winfo 'rootx path) (winfo 'rooty path)))
  ) 
  (bindtags path (append (bindtags path ) (list tag)))
  m
))

;;;   usage
;;;
;(toplevel '.my)
;(define my (tk_optionMenu '.my.menu 'sato 'a 'b 'c))
;(pack .my.menu)
;;;;   Caution!!!  entry should be symbol , number will confuse with index number
;;;;    , which begins from 0!!!
;;;; 
;(eval `(, my 'entryconfigure 'a :command '(format #t "a OK~%")) () )
;(eval `(, my 'entryconfigure 'b :command '(format #t "b OK~%")) () )
;;(eval `(, my 'entryconfigure 'c :command '(format #t "c OK~%")) () )





