;;; save data
;;;
(define (save-data )
  (let ((s 0))
    (do ((x #f))
        ( x)
       (set! s (entry-get ".dat3"))
       (set! x (not (file-exists? s)))
    )
  (if (or (equal? s ".dat3")(equal? s ""))
     ()
    (save-data-sub s)
  )
))
(define (save-data-sub  file)
  (let ((s 0) (data *data*))
    (set! s (open-output-file file))
    (format s "# ~s ~%" *mode* )
    (format s "# ~a ~%" *comment* )
    (format s "# theta: ~s phi:  ~s  ~%" *theta-deg* *phi-deg* )
    (do ((x 0))
        ((null? data))
        (set! x (pop data))
        (do ((y 0))
           ((null? x))
           (set! y (pop x))
           (map (lambda(x) (write  x s) (display " " s)) y)
           ( newline s)
        )
       (write 's s)
        (display  " s" s)
         ( newline s)
   )
  (close-port s)
))
 
        
